/* $Id: gii.h,v 1.6 1998/11/19 00:59:00 marcus Exp $
******************************************************************************

   LibGII API header file
 
   Copyright (C) 1998 Andreas Beck	[becka@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/
              
#ifndef _GGI_GII_H
#define _GGI_GII_H

#include <ggi/events.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef _BUILDING_LIBGII
typedef void *gii_input_t;
#endif

/*
******************************************************************************
 libGII function definitions
******************************************************************************
*/

/* Enter and leave the library.
 */ 
int  giiInit(void);
int  giiExit(void);
void giiPanic(char *format, ...);

/* Open a new Input - use input `NULL' for autoselect.
 */
gii_input_t	giiOpen(const char *input,...);
int		giiClose(gii_input_t vis);

/* Get info 
 */
int		giiGetSelectFdset(gii_input_t vis, fd_set *readfds, int *haspolled);

/* Input management
 */

gii_input_t giiJoinInputs(gii_input_t inp, gii_input_t inp2);

/* Event Handling */

gii_event_mask	giiEventPoll(gii_input_t vis,gii_event_mask mask,struct timeval *t);
int 		giiEventRead(gii_input_t vis,gii_event *ev,gii_event_mask mask);
int 		giiEventSend(gii_input_t vis,gii_event *ev);
int		giiSetEventMask(gii_input_t vis, gii_event_mask evm);
gii_event_mask	giiGetEventMask(gii_input_t vis);

#define giiAddEventMask(vis,mask)  \
		giiSetEventMask((vis), giiGetEventMask(vis) | (mask))
#define giiRemoveEventMask(vis,mask)  \
		giiSetEventMask((vis), giiGetEventMask(vis) & ~(mask))

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _GGI_GII_H */
